<?php
require '../includes/config.php';
require '../includes/init.php';
session_start();
unset($_SESSION['captcha']);
$_SESSION['captcha'] = rand(1, 100);
$x1 = rand(1,100);
$x2 = rand(1,10);
$x = SHA1(($x1 + $x2).$_SESSION['captcha']);
if ($user -> LoggedIn())
{
header('Location: login.php');
}
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <script>
		function register()
		{
		var username=$('#username').val();
		var password=$('#password').val();
		var rpassword=$('#rpassword').val();
		var email=$('#email').val();
		var scode=$('#scode').val();
		var question=$('#question').val();
		var answer="<?php echo $x; ?>";
		document.getElementById("registerdiv").style.display="none";
		document.getElementById("registerimage").style.display="inline"; 
		var xmlhttp;
		if (window.XMLHttpRequest)
		  {// code for IE7+, Firefox, Chrome, Opera, Safari
		  xmlhttp=new XMLHttpRequest();
		  }
		else
		  {// code for IE6, IE5
		  xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		  }
		xmlhttp.onreadystatechange=function()
		  {
		  if (xmlhttp.readyState==4 && xmlhttp.status==200)
			{
			document.getElementById("registerdiv").innerHTML=xmlhttp.responseText;
			document.getElementById("registerimage").style.display="none";
			document.getElementById("registerdiv").style.display="inline";
			if (xmlhttp.responseText.search("Redirecting") != -1)
			{
			setInterval(function(){window.location="login.php"},3000);
			}
			}
		  }
		xmlhttp.open("POST","../ajax/login.php?type=register",true);
		xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		xmlhttp.send("username=" + username + "&password=" + password + "&rpassword=" + rpassword + "&scode=" + scode + "&email=" + email + "&question=" + question + "&answer=" + answer);
		}
		</script>
    <title><?php echo htmlspecialchars($sitename); ?> - 注册</title>
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="robots" content="all,follow">
    <!-- Bootstrap CSS-->
    <link rel="stylesheet" href="../assets/login/css/bootstrap.min.css">
    <link rel="stylesheet" href="//fonts.geekzu.org/css?family=Poppins:300,400,700">
	<link rel="stylesheet" href="../assets/login/css/style.default.css" id="theme-stylesheet">
	<script type="application/x-javascript"> addEventListener("load", function() { setTimeout(hideURLbar, 0); }, false);
		function hideURLbar(){ window.scrollTo(0,1); } </script>
  </head>
  <body>
    <div class="page login-page">
      <div class="container d-flex align-items-center">
        <div class="form-holder has-shadow">
          <div class="row">
            <!-- Logo & Information Panel-->
            <div class="col-lg-6">
              <div class="info d-flex align-items-center">
                <div class="content">
                  <div class="logo">
                    <h1>欢迎注册<img id="registerimage" src="../assets/images/loading.gif" style="display:none"/></h1>
                  </div>
                  <p><?php echo htmlspecialchars($sitename); ?></p>
                  <p>瞬间洪水 / 网络断路器 </p>
                </div>
              </div>
            </div>
            <!-- Form Panel    -->
            <div class="col-lg-6 bg-white">
              <div class="form d-flex align-items-center">
                <div class="content">
					<div id="registerdiv" style="display:none"></div>
                    <div class="form-group">
                      <input class="input-material" type="text" id="username" name="Name" placeholder="请输入用户名/姓名" >
								      <div class="invalid-feedback">
								        	用户名必须在2~10位之间
								      </div>
                    </div>
                    <div class="form-group">
                      <input class="input-material" type="password" name="Password" id="password" placeholder="请输入密码"   >
                    	<div class="invalid-feedback">
								        	密码必须在6~10位之间
								      </div>
                    </div>
                    <div class="form-group">
                      <input class="input-material" type="password"  name="Password" id="rpassword" placeholder="确认密码"   >
                    	<div class="invalid-feedback">
								        	两次密码必须相同 且在6~10位之间
								      </div>
					</div>
					<div class="form-group">
						<input class="input-material" type="text"  name="Name" id="scode" placeholder="QQ号"   >
						  <div class="invalid-feedback">
							QQ帐号，注册后不可修改
										</div>
					  </div>
					  <div class="form-group">
						<input class="input-material" type="text"  name="Name" id="email" placeholder="QQ邮箱"   >
						  <div class="invalid-feedback">
							QQ邮箱，注册后不可修改
										</div>
					  </div>
					  <div class="form-group">
						<input class="input-material" type="text" name="Password" id="question" placeholder="<?php echo ''.$x1.'+'.$x2.'?'; ?>"   >
						  <div class="invalid-feedback">
											  验证码
										</div>
					  </div>
                    <div class="form-group">
                      <button onClick="register()"  type="button" name="registerSubmit" class="btn btn-primary">注册</button>
                    </div>
                  <small>已有账号?</small><a href="login.php" class="signup">&nbsp;登录</a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- JavaScript files-->
    <script src="../assets/login/js/jquery.min.js"></script>
    <script src="../assets/login/js/bootstrap.min.js"></script>
    <script>
    	$(function(){
    		/*错误class  form-control is-invalid
    		正确class  form-control is-valid*/
    		var flagName=false;
    		var flagPas=false;
    		var flagPass=false;
    		/*验证用户名*/
    		var name,passWord,passWords;
    		$("#username").change(function(){
    			name=$("#username").val();
    			if(name.length<2||name.length>10){
    				$("#username").removeClass("form-control is-valid")
    				$("#username").addClass("form-control is-invalid");
    				flagName=false;
    			}else{
    				$("#username").removeClass("form-control is-invalid")
    				$("#username").addClass("form-control is-valid");
    				flagName=true;
    			}
    		})
    		/*验证密码*/
    		$("#password").change(function(){
    			passWord=$("#password").val();
    			if(passWord.length<6||passWord.length>18){
    				$("#password").removeClass("form-control is-valid")
    				$("#password").addClass("form-control is-invalid");
    				flagPas=false;
    			}else{
    				$("#password").removeClass("form-control is-invalid")
    				$("#password").addClass("form-control is-valid");
    				flagPas=true;
    			}
    		})
    		/*验证确认密码*/
    		$("#rpassword").change(function(){
    			passWords=$("#rpassword").val();
    			if((passWord!=passWords)||(passWords.length<6||passWords.length>18)){
    				$("#rpassword").removeClass("form-control is-valid")
    				$("#rpassword").addClass("form-control is-invalid");
    				flagPass=false;
    			}else{
    				$("#rpassword").removeClass("form-control is-invalid")
    				$("#rpassword").addClass("form-control is-valid");
    				flagPass=true;
    			}
    		})
    		
    		
    		$("#regbtn").click(function(){
    			if(flagName&&flagPas&&flagPass){
    				localStorage.setItem("name",name);
    				localStorage.setItem("passWord",passWord);
    				location="login.php"
    			}else{
    				if(!flagName){
    					$("#username").addClass("form-control is-invalid");
    				}
    				if(!flagPas){
    					$("#password").addClass("form-control is-invalid");
    				}
    				if(!flagPass){
    					$("#rpassword").addClass("form-control is-invalid");
    				}
    			}
    		})
    	})
    </script>
  </body>
</html>