<?php
include("header.php");
error_reporting(0);
if (!($user -> isAdmin($odb)))
{
	header('location: ../index.php');
	die();
}
if (isset($_POST['delete']))
{
$delete = $_POST['delete'];
$SQL = $odb -> prepare("DELETE FROM `methods` WHERE `id` = :id");
$SQL -> execute(array(':id' => $delete));
$delete=success('方法已被删除');
}
if (isset($_POST['add']))
{
if (empty($_POST['name']) || empty($_POST['fullname']) || empty($_POST['type']))
{
$error = '请验证所有字段';
}

if (empty($error))
{
$name = $_POST['name'];
$fullname = $_POST['fullname'];
$type = $_POST['type'];
if ($system=='servers') {$command = $_POST['command'];} else {$command = '';}
$SQLinsert = $odb -> prepare("INSERT INTO `methods` VALUES(NULL, :name, :fullname, :type, :command)");
$SQLinsert -> execute(array(':name' => $name, ':fullname' => $fullname, ':type' => $type, ':command' => $command));
$ffmsg= success('方法已被添加');
}
else
{
$ffmsg= error($error);
}
}
if (isset($_POST['deleteblacklist']))
{
$delete = $_POST['deleteblacklist'];
$SQL = $odb -> query("DELETE FROM `blacklist` WHERE `ID` = '$delete'");
$deleteblacklistmsg=success('黑名单已被删除');
}
if (isset($_POST['addblacklist']))
{
if (empty($_POST['value']))
{
$error = '请验证所有字段';
}
$value = $_POST['value'];
$type = $_POST['type'];
if (empty($error))
{
$SQLinsert = $odb -> prepare("INSERT INTO `blacklist` VALUES(NULL, :value, :type)");
$SQLinsert -> execute(array(':value' => $value, ':type' => $type));
$hmd=success('黑名单已被添加');
}
else
{
$hmd=error($error);
}
}
if (isset($_POST['deleteapi']))
{
$delete = $_POST['deleteapi'];
$SQL = $odb -> prepare("DELETE FROM `api` WHERE `id` = :id");
$SQL -> execute(array(':id' => $delete));
$apimsg=success('已删除API');
}
if (isset($_POST['deleteserver']))
{
$delete = $_POST['deleteserver'];
$SQL = $odb -> prepare("DELETE FROM `servers` WHERE `id` = :id");
$SQL -> execute(array(':id' => $delete));
$apimsg=success('已删除服务器');
}
if (isset($_POST['addapi']))
{
if (empty($_POST['api']) || empty($_POST['name']) || empty($_POST['slots']) || empty($_POST['methods']))
{
$error = '请验证所有字段';
}
$api = $_POST['api'];
$name = $_POST['name'];
$slots = $_POST['slots'];
$methods = implode(" ",$_POST['methods']);
if (!(is_numeric($slots)))
{
$error = '插槽字段必须是数字的';
}
$parameters = array("[host]", "[port]", "[time]", "[method]");
foreach ($parameters as $parameter)
{
if (strpos($api,$parameter) == false)
{
$error = '找不到参数 "'.$parameter.'"';
}
}
if(!ctype_alnum(str_replace(' ','',$name)) || !ctype_alnum(str_replace(' ','',$methods)))
{
$error = '名称或方法字段中的无效字符';
}
if (empty($error))
{
$SQLinsert = $odb -> prepare("INSERT INTO `api` VALUES(NULL, :name, :api, :slots, :methods)");
$SQLinsert -> execute(array(':api' => $api, ':name' => $name, ':slots' => $slots, ':methods' => $methods));
$apimsgs=success('已添加API');
}
else
{
$apimsgs=error($error);
}
}

if (isset($_POST['addserver']))
{
if (empty($_POST['ip']) || empty($_POST['password']) || empty($_POST['name']) || empty($_POST['slots']) || empty($_POST['methods']))
{
$error = '请验证所有字段';
}
$name = $_POST['name'];
$ip = $_POST['ip'];
$password = $_POST['password'];
$slots = $_POST['slots'];
$methods = implode(" ",$_POST['methods']);
if (!(is_numeric($slots)))
{
$error = '插槽字段必须是数字的';
}
if (!filter_var($ip, FILTER_VALIDATE_IP))
{
$error = 'IP是无效的';
}
if(!ctype_alnum(str_replace(' ','',$name)) || !ctype_alnum(str_replace(' ','',$methods)))
{
$error = '名称或命令字段中的无效字符';
}
if (empty($error))
{
$SQLinsert = $odb -> prepare("INSERT INTO `servers` VALUES(NULL, :name, :ip, :password, :slots, :methods)");
$SQLinsert -> execute(array(':name' => $name, ':ip' => $ip, ':password' => $password, ':slots' => $slots, ':methods' => $methods));
$apimsgs= success('已添加服务器');
}
else
{
$apimsgs= error($error);
}
}
?>
<div class="main-panel">
			<div class="content">
				<div class="page-inner">
					<div class="page-header">
						<h4 class="page-title">攻击设置</h4>
						<ul class="breadcrumbs">
							<li class="nav-home">
								<a href="#">
									<i class="flaticon-home"></i>
								</a>
							</li>
							<li class="separator">
								<i class="flaticon-right-arrow"></i>
							</li>
							<li class="nav-item">
								<a href="arack.php">攻击设置</a>
							</li>
						</ul>
					</div>
					<div class="row">
						<div class="col-md-12">
							<div class="card">
								<div class="card-header">
									<h4 class="card-title">攻击设置</h4>
								</div>
								<div class="card-body">
									<ul class="nav nav-pills nav-secondary nav-pills-no-bd" id="pills-tab-without-border" role="tablist">
										<li class="nav-item">
											<a class="nav-link active" id="pills-home-tab-nobd" data-toggle="pill" href="#ffgl" role="tab" aria-controls="pills-home-nobd" aria-selected="true">方法管理</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-profile-tab-nobd" data-toggle="pill" href="#tjxff" role="tab" aria-controls="pills-profile-nobd" aria-selected="false">添加新方法</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-contact-tab-nobd" data-toggle="pill" href="#hmdgl" role="tab" aria-controls="pills-contact-nobd" aria-selected="false">黑名单管理</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-contact-tab-nobd" data-toggle="pill" href="#tjhmd" role="tab" aria-controls="pills-contact-nobd" aria-selected="false">添加黑名单</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-contact-tab-nobd" data-toggle="pill" href="#gjgl" role="tab" aria-controls="pills-contact-nobd" aria-selected="false"><?php if ($system == 'api') { echo 'API'; } else { echo 'Servers'; } ?>管理</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-contact-tab-nobd" data-toggle="pill" href="#tjxdgj" role="tab" aria-controls="pills-contact-nobd" aria-selected="false">添加一个新的<?php if ($system == 'api') { echo 'API'; } else { echo 'Server'; } ?></a>
										</li>
									</ul>
									<div class="tab-content mt-2 mb-3" id="pills-without-border-tabContent">
										<div class="tab-pane fade show active" id="ffgl" role="tabpanel" aria-labelledby="pills-home-tab-nobd">
											<div class="table-responsive">
											<table class="table table-head-bg-success mt-3">
										<thead>
											<tr>
												<th scope="col">名称</th>
												<th scope="col">标签</th>
												<th scope="col">类型</th>
												<?php if($system == 'servers'){echo '<th scope="col">command</th>';}?>
												<th scope="col">删除</th>
											</tr>
										</thead>
										<tbody>
										<form method="post">
<?php
$SQLGetMethods = $odb -> query("SELECT * FROM `methods`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$id = $getInfo['id'];
$name = $getInfo['name'];
$fullname = $getInfo['fullname'];
$type = $getInfo['type'];
if ($system == 'servers') {$command = '<td>'.$getInfo['command'].'</td>';} else {$command = '';}
echo '<tr><td>'.htmlspecialchars($name).'</td><td>'.htmlspecialchars($fullname).'</td><td>'.$type.'</td>'.$command.'<td><button name="delete" value="'.$id.'" class="btn btn-danger">删除</button></td></tr>';
}
if (empty($SQLGetMethods))
{
echo 'No logs';
}
?>
</form>	
										</tbody>
									</table>	
										</div>
										</div>
										<div class="tab-pane fade" id="tjxff" role="tabpanel" aria-labelledby="pills-profile-tab-nobd">
<?php echo $ffmsg;?>
<form class="am-form am-form-horizontal" method="post">
<div class="card-body">
									<div class="row">
										<div class="col-md-12 col-lg-12">
											<div class="form-group">
												<label for="title2">名称</label>
												<input type="title" name="name" class="form-control" id="name" placeholder="名称">
												<small id="titleHelp" class="form-text text-muted">这将在添加服务器时使用</small>
											</div>
											<div class="form-group">
												<label for="password">标签名称</label>
												<input type="text" name="fullname" class="form-control" id="fullname" placeholder="标签名称">
												<small id="titleHelp" class="form-text text-muted">这将显示在前台攻击方法中</small>
											</div>
											<div class="form-group">
												<label for="largeSelect">类型</label>
												<select class="form-control form-control-lg" id="type" name="type">
<option value="spe">Special</option>
<option value="tcp">TCP</option>
<option value="udp">UDP</option>
<option value="layer7">Layer7</option>
												</select>
											</div>
<?php
if ($system == 'servers')
{
?>
											<div class="form-group">
												<label for="password">Command</label>
												<input type="text" title="Syntax: {$host} {$port} {$time}" name="command" class="form-control" id="command" placeholder="Syntax: {$host} {$port} {$time}">
												<small id="titleHelp" class="form-text text-muted">说白了脚本用法</small>
											</div>
<?php 
}
?>
										</div>
									</div>
								</div>
<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="add" class="btn btn-block btn-success">提交</button>
</div>
</div>
</form>
										</div>
										<div class="tab-pane fade" id="hmdgl" role="tabpanel" aria-labelledby="pills-contact-tab-nobd">
											<div class="table-responsive">
											<table class="table table-head-bg-success mt-3">
										<thead>
											<tr>
												<th scope="col">黑名单</th>
												<th scope="col">类型</th>
												<th scope="col">删除</th>
											</tr>
										</thead>
										<tbody>
											<form method="post">
<?php
$SQLGetMethods = $odb -> query("SELECT * FROM `blacklist`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$id = $getInfo['ID'];
$value = $getInfo['data'];
$type = $getInfo['type'];
echo '<tr><td>'.htmlspecialchars($value).'</td><td>'.htmlspecialchars($type).'</td><td><button name="deleteblacklist" value="'.$id.'"class="btn btn-danger">删除</button></td></tr>';
}
?>
</form>
										</tbody>
									</table>
										</div>
										</div>
										<div class="tab-pane fade" id="tjhmd" role="tabpanel" aria-labelledby="pills-profile-tab-nobd">
<?php echo $hmd;?>
<form class="am-form am-form-horizontal" method="post">
								<div class="card-body">
									<div class="row">
										<div class="col-md-12 col-lg-12">
											<div class="form-group">
												<label for="title2">黑名单</label>
												<input type="title" name="value" class="form-control" id="value" >
												<small id="titleHelp" class="form-text text-muted">请输入黑名单</small>
											</div>
											<div class="form-group form-floating-label">
												<select class="form-control input-border-bottom" name="type" id="type" required="">
													<option value="">&nbsp;</option>
													<option value="victim">网站/IP</option>
												</select>
												<label for="selectFloatingLabel" class="placeholder">类型</label>
											</div>
										</div>
									</div>
								</div>
<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="addblacklist" class="btn btn-block btn-success">提交</button>
</div>
</div>
</form>
										</div>
										<div class="tab-pane fade" id="gjgl" role="tabpanel" aria-labelledby="pills-contact-tab-nobd">
<?php echo $apimsg;?>
											<div class="table-responsive">
											<table class="table table-head-bg-success mt-3">
										<thead>
											<tr>
<?php if ($system == 'api') { ?>
												<th scope="col">名称</th>
												<th scope="col">API</th>
												<th scope="col">插槽</th>
												<th scope="col">方法</th>
												<th scope="col">删除</th>
<?php } else { ?>
												<th scope="col">名称</th>
												<th scope="col">IP</th>
												<th scope="col">插槽</th>
												<th scope="col">方法</th>
												<th scope="col">删除</th>
<?php } ?>
											</tr>
										</thead>
										<tbody>
<form method="post">
<?php
if ($system == 'api') {
$SQLGetMethods = $odb -> query("SELECT * FROM `api`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$id = $getInfo['id'];
$api = $getInfo['api'];
$name = $getInfo['name'];
$slots = $getInfo['slots'];
$methods = $getInfo['methods'];
echo '<tr><td>'.htmlspecialchars($name).'</td><td>'.htmlspecialchars($api).'</td><td>'.htmlspecialchars($slots).'</td><td>'.htmlspecialchars($methods).'</td><td><button type="submit" title="Delete API" name="deleteapi" value="'.htmlspecialchars($id).'" class="btn btn-danger">删除</button></td></tr>';
}
} else {
$SQLGetMethods = $odb -> query("SELECT * FROM `servers`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$name = $getInfo['name'];
$id = $getInfo['id'];
$ip = $getInfo['ip'];
$slots = $getInfo['slots'];
$methods = $getInfo['methods'];
echo '<tr><td>'.htmlspecialchars($name).'</td><td>'.htmlspecialchars($ip).'</td><td>'.htmlspecialchars($slots).'</td><td>'.htmlspecialchars($methods).'</td><td><button type="submit" title="Delete Server" name="deleteserver" value="'.htmlspecialchars($id).'" class="btn btn-danger">删除</button></td></tr>';
}
}
?>
</form>
										</tbody>
									</table>
										</div>
										</div>
										<div class="tab-pane fade" id="tjxdgj" role="tabpanel" aria-labelledby="pills-contact-tab-nobd">
<?php echo $apimsgs;?>
<form class="am-form am-form-horizontal" method="post">
<?php if ($system == 'api') { ?>
<div class="card-body">
									<div class="row">
										<div class="col-md-12 col-lg-12">
											<div class="form-group">
												<label for="title2">API 名称</label>
												<input type="title" name="name" class="form-control" id="name" placeholder="API 名称">
												<small id="titleHelp" class="form-text text-muted">请输入API 名称</small>
											</div>
											<div class="form-group">
												<label for="password">API 地址</label>
												<input type="text" title="Syntax: [host], [port], [time], [method]" name="api" class="form-control" id="api" placeholder="Syntax: [host], [port], [time], [method]">
											</div>
											<div class="form-group">
												<label for="title2">插槽</label>
												<input type="title" name="slots" class="form-control" id="slots" placeholder="插槽">
											</div>
											<div class="form-group">
												<label for="exampleFormControlSelect2">方法</label>
												<select id="methods[]"class="form-control"name="methods[]" multiple="multiple">
<?php
$SQLGetMethods = $odb -> query("SELECT * FROM `methods`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$name = $getInfo['name'];
echo '<option value="'.$name.'">'.$name.'</option>';
}
?>
												</select>
											</div>
											
											</div>
										</div>
									</div>
								
<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="addapi" class="btn btn-block btn-success">提交</button>
</div>
</div>
</form>
</div>
<?php
}
else
{
?>

										<div class="card-body">
									<div class="row">
										<div class="col-md-12 col-lg-12">
											<div class="form-group">
												<label for="title2">名称</label>
												<input type="title" name="name" class="form-control" id="name" placeholder="名称">
												<small id="titleHelp" class="form-text text-muted">请输入API 名称</small>
											</div>
											<div class="form-group">
												<label for="password">IP</label>
												<input type="text" title="IP" name="ip" class="form-control" id="ip" placeholder="IP">
											</div>
											<div class="form-group">
												<label for="password">密码</label>
												<input type="password" title="password" name="password" class="form-control" id="ip" placeholder="password">
											</div>
											<div class="form-group">
												<label for="title2">插槽</label>
												<input type="title" name="slots" class="form-control" id="slots" placeholder="插槽">
											</div>
																						<div class="form-group">
												<label for="exampleFormControlSelect2">方法</label>
												<select id="methods[]"class="form-control"name="methods[]" multiple="multiple">
<?php
$SQLGetMethods = $odb -> query("SELECT * FROM `methods`");
while($getInfo = $SQLGetMethods -> fetch(PDO::FETCH_ASSOC))
{
$name = $getInfo['name'];
echo '<option value="'.$name.'">'.$name.'</option>';
}
?>
												</select>
											</div>
											</div>
										</div>
									</div>
								</div>
<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="addserver" class="btn btn-block btn-success">提交</button>
</div>
</div>
</form>
</div>
<?php }?>
										</div>

									</div>
								</div>
							</div>
						</div>
					</div>
				</div>

<?php
include("script.php");
?>