<?php
include("header.php");
if (!($user -> isAdmin($odb)))
{
	header('location: ../index.php');
	die();
}
?>
<?php
$paginaname = '查看日志';
?>
<div class="main-panel">
			<div class="content">
				<div class="page-inner">
					<div class="page-header">
						<h4 class="page-title">查看日志</h4>
						<ul class="breadcrumbs">
							<li class="nav-home">
								<a href="#">
									<i class="flaticon-home"></i>
								</a>
							</li>
							<li class="separator">
								<i class="flaticon-right-arrow"></i>
							</li>
							<li class="nav-item">
								<a href="log.php">查看日志</a>
							</li>
						</ul>
					</div>
					<div class="row">
						<div class="col-md-12">
							<div class="card">
								<div class="card-header">
									<h4 class="card-title">查看日志</h4>
								</div>
								<div class="card-body">
									<ul class="nav nav-pills nav-secondary nav-pills-no-bd" id="pills-tab-without-border" role="tablist">
										<li class="nav-item">
											<a class="nav-link active" id="pills-home-tab-nobd" data-toggle="pill" href="#dlrz" role="tab" aria-controls="pills-home-nobd" aria-selected="true">登陆日志</a>
										</li>
										<li class="nav-item">
											<a class="nav-link" id="pills-profile-tab-nobd" data-toggle="pill" href="#gjrz" role="tab" aria-controls="pills-profile-nobd" aria-selected="false">攻击日志</a>
										</li>
									</ul>
									<div class="tab-content mt-2 mb-3" id="pills-without-border-tabContent">
										<div class="tab-pane fade show active" id="dlrz" role="tabpanel" aria-labelledby="pills-home-tab-nobd">
											<div class="table-responsive">
											<table class="table table-head-bg-success mt-3">
										<thead>
											<tr>
												<th scope="col">用户</th>
												<th scope="col">IP</th>
												<th scope="col">国家</th>
												<th scope="col">日期</th>
											</tr>
										</thead>
										<tbody>
<?php 
$SQLGetUsers = $odb -> query("SELECT * FROM `loginlogs` ORDER BY `date` DESC");
while ($getInfo = $SQLGetUsers -> fetch(PDO::FETCH_ASSOC))
{
$username = $getInfo['username'];
$ip = $getInfo['ip'];
$date = date("Y-m-d, H:i:s a" ,$getInfo['date']);
$country = $getInfo['country'];
echo '<tr><td>'.htmlspecialchars($username).'</td><td>'.htmlspecialchars($ip).'</td><td>'.$date.'</td><td>'.htmlspecialchars($country).'</td></tr>';
}
?>
										</tbody>
									</table>
										</div>
										</div>
										<div class="tab-pane fade" id="gjrz" role="tabpanel" aria-labelledby="pills-profile-tab-nobd">
											<div class="table-responsive">
											<table class="table table-head-bg-primary mt-5">
										<thead>
											<tr>
												<th scope="col">用户</th>
												<th scope="col">HOST</th>
												<th scope="col">时间（秒）</th>
												<th scope="col">服务器</th>
												<th scope="col">日期</th>
											</tr>
										</thead>
										<tbody>
<?php
$SQLGetLogs = $odb -> query("SELECT * FROM `logs` ORDER BY `date` DESC");
while($getInfo = $SQLGetLogs -> fetch(PDO::FETCH_ASSOC))
{
$user = $getInfo['user'];
$host = $getInfo['ip'];
if (filter_var($host, FILTER_VALIDATE_URL)) {$port='';} else {$port=':'.$getInfo['port'];}
$time = $getInfo['time'];
$method = $getInfo['method'];
$handler = $getInfo['handler'];
$date = date("Y-m-d, H:i:s a" ,$getInfo['date']);
echo '<tr><td>'.htmlspecialchars($user).'</td><td>'.htmlspecialchars($host).$port.' ('.htmlspecialchars($method).')<br></td><td>'.$time.'</td><td>'.htmlspecialchars($handler).'</td><td>'.$date.'</td></tr>';
}
?>
										</tbody>
									</table>
										</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
<?php
include("script.php");
?>