<?php 
if (basename($_SERVER['SCRIPT_FILENAME']) == basename(__FILE__)) {exit("NOT ALLOWED");}
ob_start();
require_once '../includes/config.php';
require_once '../includes/init.php';
if (!($user -> LoggedIn()))
{
	header('location: ../user/login.php');
	die();
}
if (!($user -> isSupporter($odb)))
{
	header('location: ../index.php');
	die();
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<title>后台管理 - <?php echo htmlspecialchars($sitename); ?> - <?php echo htmlspecialchars($description); ?></title>
	<meta name="description" content="<?php echo htmlspecialchars($description); ?>">
	<meta name="keywords" content="<?php echo htmlspecialchars($tos); ?>">
	<meta content='width=device-width, initial-scale=1.0, shrink-to-fit=no' name='viewport' />
	<link rel="icon" href="../assets/img/icon.ico" type="image/x-icon"/>

	<!-- Fonts and icons -->
	<script src="../assets/js/plugin/webfont/webfont.min.js"></script>
	<script>
		WebFont.load({
			google: {"families":["Lato:300,400,700,900"]},
			custom: {"families":["Flaticon", "Font Awesome 5 Solid", "Font Awesome 5 Regular", "Font Awesome 5 Brands", "simple-line-icons"], urls: ['../assets/css/fonts.min.css']},
			active: function() {
				sessionStorage.fonts = true;
			}
		});
	</script>

	<!-- CSS Files -->
	<link rel="stylesheet" href="../assets/css/bootstrap.min.css">
	<link rel="stylesheet" href="../assets/css/atlantis.min.css">

	<!-- CSS Just for demo purpose, don't include it in your project -->
	<link rel="stylesheet" href="../assets/css/demo.css">
</head>
<body data-background-color="dark">
	<div class="wrapper">
		<div class="main-header">
			<!-- Logo Header -->
			<div class="logo-header" data-background-color="dark2">
				
				<a href="index.php" class="logo">
					<img src="../assets/img/logo.svg" alt="navbar brand" class="navbar-brand">
				</a>
				<button class="navbar-toggler sidenav-toggler ml-auto" type="button" data-toggle="collapse" data-target="collapse" aria-expanded="false" aria-label="Toggle navigation">
					<span class="navbar-toggler-icon">
						<i class="icon-menu"></i>
					</span>
				</button>
				<button class="topbar-toggler more"><i class="icon-options-vertical"></i></button>
				<div class="nav-toggle">
					<button class="btn btn-toggle toggle-sidebar">
						<i class="icon-menu"></i>
					</button>
				</div>
			</div>
			<!-- End Logo Header -->
<!-- Navbar Header -->
			<nav class="navbar navbar-header navbar-expand-lg" data-background-color="dark">
				
				<div class="container-fluid">
					<div class="collapse" id="search-nav">
						<form class="navbar-left navbar-form nav-search mr-md-3">
							<div class="input-group">
								<div class="input-group-prepend">
									<button type="submit" class="btn btn-search pr-1">
										<i class="fa fa-search search-icon"></i>
									</button>
								</div>
								<input type="text" placeholder="Search ..." class="form-control">
							</div>
						</form>
					</div>
					<ul class="navbar-nav topbar-nav ml-md-auto align-items-center">
						<li class="nav-item toggle-nav-search hidden-caret">
							<a class="nav-link" data-toggle="collapse" href="#search-nav" role="button" aria-expanded="false" aria-controls="search-nav">
								<i class="fa fa-search"></i>
							</a>
						</li>
						<li class="nav-item dropdown hidden-caret">
							<a class="nav-link dropdown-toggle" href="#" id="messageDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
								<i class="fa fa-envelope"></i>
							</a>
							<ul class="dropdown-menu messages-notif-box animated fadeIn" aria-labelledby="messageDropdown">
								<li>
									<div class="dropdown-title d-flex justify-content-between align-items-center">
										工单通知									
										<a href="list.php" class="small">查看全部</a>
									</div>
								</li>
								<li>
									<div class="message-notif-scroll scrollbar-outer">
										<div class="notif-center">
<?php 
$SQLGetTickets = $odb -> query("SELECT * FROM `tickets` WHERE `status` = '等待管理响应' ORDER BY `date` DESC");
while ($getInfo = $SQLGetTickets -> fetch(PDO::FETCH_ASSOC))
{
$username = $getInfo['username'];
$id = $getInfo['id'];
$subject = $getInfo['subject'];
$date = date("Y-m-d, h:i:s a" ,$getInfo['date']);
$userid = $odb->query("SELECT `ID` FROM `users` WHERE `username` = '$username'")->fetchColumn(0);
echo '<a href="ticket.php?id='.$id.'">
												<div class="notif-img"> 
													<img src="../assets/img/jm_denis.jpg" alt="Img Profile">
												</div>
												<div class="notif-content">
													<span class="subject">'.htmlspecialchars($subject).'</span>
													<span class="block">
														'.htmlspecialchars($username).'
													</span>
													<span class="time">未处理</span> 
												</div>
											</a>';
}
?>          
										</div>
									</div>
								</li>
								<li>
									<a class="see-all" href="javascript:void(0);">已读<i class="fa fa-angle-right"></i> </a>
								</li>
							</ul>
						</li>
						<li class="nav-item dropdown hidden-caret">
							<a class="nav-link dropdown-toggle" href="#" id="notifDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
								<i class="fa fa-bell"></i>
								<span class="notification">4</span>
							</a>
							<ul class="dropdown-menu notif-box animated fadeIn" aria-labelledby="notifDropdown">
								<li>
									<div class="dropdown-title">公告通知</div>
								</li>
								<li>
									<div class="notif-scroll scrollbar-outer">
										<div class="notif-center">
<?php
$newssql = $odb -> query("SELECT * FROM `news` ORDER BY `date` DESC LIMIT 4");
while($row = $newssql ->fetch())
{
$id = $row['ID'];
$title = $row['title'];
$content = $row['content'];
$autor = $row['author'];
echo '
<a href="#">
												<div class="notif-icon notif-success"> <i class="fa fa-comment"></i> </div>
												<div class="notif-content">
													<span class="block">
														'.htmlspecialchars($content).'
													</span>
													<span class="time">'.date("Y-m-d" ,$row['date']).'</span> 
												</div>
											</a>';
}
?>
										</div>
									</div>
								</li>
								<li>
									<a class="see-all" href="javascript:void(0);">已读<i class="fa fa-angle-right"></i> </a>
								</li>
							</ul>
						</li>
						<li class="nav-item dropdown hidden-caret">
							<a class="nav-link" data-toggle="dropdown" href="#" aria-expanded="false">
								<i class="fas fa-layer-group"></i>
							</a>
							<div class="dropdown-menu quick-actions quick-actions-info animated fadeIn">
								<div class="quick-actions-header">
									<span class="title mb-1">Quick Actions</span>
									<span class="subtitle op-8">Shortcuts</span>
								</div>
								<div class="quick-actions-scroll scrollbar-outer">
									<div class="quick-actions-items">
										<div class="row m-0">
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-file-1"></i>
													<span class="text">Generated Report</span>
												</div>
											</a>
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-database"></i>
													<span class="text">Create New Database</span>
												</div>
											</a>
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-pen"></i>
													<span class="text">Create New Post</span>
												</div>
											</a>
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-interface-1"></i>
													<span class="text">Create New Task</span>
												</div>
											</a>
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-list"></i>
													<span class="text">Completed Tasks</span>
												</div>
											</a>
											<a class="col-6 col-md-4 p-0" href="#">
												<div class="quick-actions-item">
													<i class="flaticon-file"></i>
													<span class="text">Create New Invoice</span>
												</div>
											</a>
										</div>
									</div>
								</div>
							</div>
						</li>
<?php $result=$odb->query("select * from users where username='".$_SESSION['username']."' limit 1");
		while($row = $result->fetch(PDO::FETCH_ASSOC)){
?>
						<li class="nav-item dropdown hidden-caret">
							<a class="dropdown-toggle profile-pic" data-toggle="dropdown" href="#" aria-expanded="false">
								<div class="avatar-sm">
									<img src="//q4.qlogo.cn/headimg_dl?dst_uin=<?php echo $row['scode'];?>&spec=640" alt="..." class="avatar-img rounded-circle">
								</div>
							</a>
							<ul class="dropdown-menu dropdown-user animated fadeIn">
								<div class="dropdown-user-scroll scrollbar-outer">
									<li>
										<div class="user-box">
											<div class="avatar-lg"><img src="//q4.qlogo.cn/headimg_dl?dst_uin=<?php echo $row['scode'];?>&spec=640" alt="image profile" class="avatar-img rounded"></div>
											<div class="u-text">
												<h4><?php echo $_SESSION['username']; ?></h4>
												<p class="text-muted"><?php echo $row['email'];?></p>
												<a href="xiugaimima.php" class="btn btn-xs btn-secondary btn-sm">修改密码</a>
											</div>
										</div>
									</li>
									<li>
										<div class="dropdown-divider"></div>
										<a class="dropdown-item" href="km.php">生成卡密</a>
										<a class="dropdown-item" href="ulist.php">用户管理</a>
<?php
if ($user -> isAdmin($odb)) {
?>
										<div class="dropdown-divider"></div>
										<a class="dropdown-item" href="../admin/">后台管理</a>
<?php }?>
<?php
if ($user -> isSupporter($odb)) {
?>
										<div class="dropdown-divider"></div>
										<a class="dropdown-item" href="../agent/">代理后台</a>
<?php }?>
										<div class="dropdown-divider"></div>
										<a class="dropdown-item" href="../home/index.php">退出登录</a>
									</li>
								</div>
							</ul>
						</li>
<?php }?>
					</ul>
				</div>
			</nav>
			<!-- End Navbar -->
		</div>

		<!-- Sidebar -->
<?php $result=$odb->query("select * from users where username='".$_SESSION['username']."' limit 1");
		while($row = $result->fetch(PDO::FETCH_ASSOC)){
?>
		<div class="sidebar sidebar-style-2" data-background-color="dark2">
			<div class="sidebar-wrapper scrollbar scrollbar-inner">
				<div class="sidebar-content">
					<div class="user">
						<div class="avatar-sm float-left mr-2">
							<img src="//q4.qlogo.cn/headimg_dl?dst_uin=<?php echo $row['scode'];?>&spec=640" alt="..." class="avatar-img rounded-circle">
						</div>
						<div class="info">
							<a data-toggle="collapse" href="#collapseExample" aria-expanded="true">
								<span>
									<?php echo $_SESSION['username']; ?>
<?php
if ($user -> isAdmin($odb)) {
?>
									<span class="user-level">平台管理员</span>
<?php } elseif ($user -> isSupporter($odb)) { ?>
									<span class="user-level">平台代理</span>
<?php } else { ?>
									<span class="user-level">平台用户</span>
<?php }?>
									<span class="caret"></span>
								</span>
							</a>
							<div class="clearfix"></div>

							<div class="collapse in" id="collapseExample">
								<ul class="nav">
<?php
if ($user -> isAdmin($odb)) {
?>
									<li>
										<a href="../admin/">
											<span class="link-collapse">后台管理</span>
										</a>
									</li>
<?php }?>
<?php
if ($user -> isSupporter($odb)) {
?>
									<li>
										<a href="/agent/">
											<span class="link-collapse">代理后台</span>
										</a>
									</li>
<?php }?>
									<li>
										<a href="xiugaimima.php">
											<span class="link-collapse">修改密码</span>
										</a>
									</li>
								</ul>
							</div>
						</div>
					</div>
<?php }?>
					<ul class="nav nav-primary">
						<li class="nav-item active">
							<a href="index.php">
								<i class="fas fa-home"></i>
								<p>苍穹仪表盘</p>
							</a>
						</li>
						<li class="nav-section">
							<span class="sidebar-mini-icon">
								<i class="fa fa-ellipsis-h"></i>
							</span>
							<h4 class="text-section">Components</h4>
						</li>
						<li class="nav-item">
							<a href="set.php">
								<i class="fas fa-cogs"></i>
								<p>苍穹网站设置</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="attack.php">
								<i class="fas fa-bomb"></i>
								<p>苍穹攻击设置</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="km.php">
								<i class="fas fa-copyright"></i>
								<p>苍穹卡密管理</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="Package.php">
								<i class="fas fa-donate"></i>
								<p>苍穹套餐管理</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="gg.php">
								<i class="fas fa-eye-dropper"></i>
								<p>苍穹公告管理</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="ulist.php">
								<i class="fas fa-users"></i>
								<p>苍穹用户管理</p>
							</a>
						</li>
						<li class="nav-item">
							<a href="log.php">
								<i class="fas fa-info-circle"></i>
								<p>苍穹网站日志</p>
							</a>
						</li>
						</a>
						</li>
						<li class="nav-item">
							<a href="http://sc.cqioi.com/?mod=shop&gid=302&cid=4">
								<i class="fas fa-info-circle"></i>
								<p>购买官方攻击接口</p>
							</a>
						</li>
						</a>
						</li>
						<li class="nav-item">
							<a href="https://www.8idc.top/">
								<i class="fas fa-info-circle"></i>
								<p>苍穹官网</p>
							</a>
						</li>
						<li class="mx-4 mt-2">
							<a href="tencent://AddContact/?fromId=45&fromSubId=1&subcmd=all&uin=<?php echo htmlspecialchars($bitcoin); ?>&website=ddos.zhangrq.cn" class="btn btn-primary btn-block"><span class="btn-label mr-2"> <i class="fa fa-heart"></i> </span>联系客服</a> 
						</li>
					</ul>
				</div>
			</div>
		</div>
		<!-- End Sidebar -->