<?php
include("header.php");
if (!($user -> isAdmin($odb)))
{
	header('location: ../index.php');
	die();
}
?>
<div class="main-panel">
			<div class="content">
				<div class="page-inner">
					<!-- Card -->
					<h4 class="page-title">后台管理</h4>
					<div class="row">
						<div class="col-sm-6 col-md-3">
							<div class="card card-stats card-primary card-round">
								<div class="card-body">
									<div class="row">
										<div class="col-5">
											<div class="icon-big text-center">
												<i class="flaticon-users"></i>
											</div>
										</div>
										<div class="col-7 col-stats">
											<div class="numbers">
												<p class="card-category">注册用户</p>
												<h4 class="card-title"><?php echo $stats -> totalUsers($odb); ?></h4>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="col-sm-6 col-md-3">
							<div class="card card-stats card-info card-round">
								<div class="card-body">
									<div class="row">
										<div class="col-5">
											<div class="icon-big text-center">
												<i class="flaticon-interface-6"></i>
											</div>
										</div>
										<div class="col-7 col-stats">
											<div class="numbers">
												<p class="card-category">套餐用户</p>
												<h4 class="card-title"><?php echo $stats -> activeUsers($odb); ?></h4>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
<?php
$overall = 0;
$today = 0;
$month = 0;
$SQLGetMoney = $odb -> query("SELECT * FROM `payments`");
while($getInfo = $SQLGetMoney -> fetch(PDO::FETCH_ASSOC))
{
if (date('m-d') == date('m-d', $getInfo['date'])) {
$today = $getInfo['paid'] + $today;
}
if (date('m') == date('m', $getInfo['date'])) {
$month = $getInfo['paid'] + $month;
}
$overall = $getInfo['paid'] + $overall;
}
?>
						<div class="col-sm-6 col-md-3">
							<div class="card card-stats card-success card-round">
								<div class="card-body ">
									<div class="row">
										<div class="col-5">
											<div class="icon-big text-center">
												<i class="flaticon-analytics"></i>
											</div>
										</div>
										<div class="col-7 col-stats">
											<div class="numbers">
												<p class="card-category">今日收益</p>
												<h4 class="card-title">$<?php echo $today; ?></h4>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="col-sm-6 col-md-3">
							<div class="card card-stats card-secondary card-round">
								<div class="card-body ">
									<div class="row">
										<div class="col-5">
											<div class="icon-big text-center">
												<i class="flaticon-success"></i>
											</div>
										</div>
										<div class="col-7 col-stats">
											<div class="numbers">
												<p class="card-category">总体收益</p>
												<h4 class="card-title">$<?php echo $overall; ?></h4>
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="row">
						<div class="col-md-4">
							<div class="card card-info card-annoucement card-round">
								<div class="card-body text-center">
									<div class="card-opening">欢迎回来,尊敬的管理员!</div>
									<div class="card-desc">
										一定要加倍努力变得优秀，等到哪天遇到对的人才不会显得狼狈不堪，毫无准备。
									</div>
									<div class="card-detail">
										<div class="btn btn-light btn-rounded">了解</div>
									</div>
								</div>
							</div>
							<div class="card card-round">
								<div class="card-body">
									<div class="card-title fw-mediumbold">等待回复的工单</div>
									<div class="card-list">
<?php 
$SQLGetTickets = $odb -> query("SELECT * FROM `tickets` WHERE `status` = '等待管理响应' ORDER BY `date` DESC");
while ($getInfo = $SQLGetTickets -> fetch(PDO::FETCH_ASSOC))
{
$username = $getInfo['username'];
$id = $getInfo['id'];
$subject = $getInfo['subject'];
$date = date("Y-m-d, h:i:s a" ,$getInfo['date']);
$userid = $odb->query("SELECT `ID` FROM `users` WHERE `username` = '$username'")->fetchColumn(0);
echo '<div class="item-list">
											<div class="avatar">
												<img src="../assets/img/jm_denis.jpg" alt="..." class="avatar-img rounded-circle">
											</div>
											<div class="info-user ml-3">
												<div class="username">'.htmlspecialchars($subject).'</div>
												<div class="status">'.htmlspecialchars($username).'</div>
											</div>
											<a href="ticket.php?id='.$id.'"><button class="btn btn-icon btn-primary btn-round btn-xs">
												<i class="fa fa-plus"></i>
											</button></a>
										</div>';
}
?>          
									</div>
								</div>
							</div>
						</div>
						<div class="col-md-4">
							<div class="card card-post card-round">
								<img class="card-img-top" src="../assets/img/blogpost.jpg" alt="Card image cap">
								<div class="card-body">
									<div class="d-flex">
										<div class="avatar">
											<img src="//q4.qlogo.cn/headimg_dl?dst_uin=2107381896&spec=640" alt="..." class="avatar-img rounded-circle">
										</div>
										<div class="info-post ml-2">
											<p class="username"><?php echo $_SESSION['username']; ?></p>
											<p class="date text-muted"><?php echo date("Y")?>年</p>
										</div>
									</div>
									<div class="separator-solid"></div>
									<p class="card-category text-info mb-1"><a href="#">平台管理员</a></p>
									<h3 class="card-title">
										<a href="#">
											励志语录
										</a>
									</h3>
									<p class="card-text">生命里最重要的事情是要有个远大的目标，并借助才能与坚毅来完成它。</p>
									<a href="#" class="btn btn-primary btn-rounded btn-sm">Read More</a>
								</div>
							</div>
						</div>
						<div class="col-md-4">
							<div class="card card-profile">
								<div class="card-header" style="background-image: url('../assets/img/blogpost.jpg')">
									<div class="profile-picture">
										<div class="avatar avatar-xl">
											<img src="//q4.qlogo.cn/headimg_dl?dst_uin=2107381896&spec=640" alt="..." class="avatar-img rounded-circle">
										</div>
									</div>
								</div>
								<div class="card-body">
									<div class="user-profile text-center">
										<div class="name">少羽</div>
										<div class="job">俗人一个,唯有努力!</div>
										<div class="desc">伟大的程序,往往都是作者努力的心血!</div>
										<div class="social-media">
											<a class="btn btn-info btn-twitter btn-sm btn-link" href="#"> 
												<span class="btn-label just-icon"><i class="flaticon-twitter"></i> </span>
											</a>
											<a class="btn btn-danger btn-sm btn-link" rel="publisher" href="#"> 
												<span class="btn-label just-icon"><i class="flaticon-google-plus"></i> </span> 
											</a>
											<a class="btn btn-primary btn-sm btn-link" rel="publisher" href="#"> 
												<span class="btn-label just-icon"><i class="flaticon-facebook"></i> </span> 
											</a>
											<a class="btn btn-danger btn-sm btn-link" rel="publisher" href="#"> 
												<span class="btn-label just-icon"><i class="flaticon-dribbble"></i> </span> 
											</a>
										</div>
										<div class="view-profile">
											<a href="#" class="btn btn-secondary btn-block">作者</a>
										</div>
									</div>
								</div>
								<div class="card-footer">
									<div class="row user-stats text-center">
										<div class="col">
											<div class="number">125</div>
											<div class="title">Post</div>
										</div>
										<div class="col">
											<div class="number">25K</div>
											<div class="title">Followers</div>
										</div>
										<div class="col">
											<div class="number">134</div>
											<div class="title">Following</div>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
<?php
include("script.php");
?>