<?php
include("header.php");
$id = $_GET['id'];

$SQLGetInfo = $odb -> prepare("SELECT * FROM `plans` WHERE `ID` = :id LIMIT 1");
$SQLGetInfo -> execute(array(':id' => $_GET['id']));
$planInfo = $SQLGetInfo -> fetch(PDO::FETCH_ASSOC);
$currentName = $planInfo['name'];
$currentCishu = $planInfo['cishu'];
$currentMbt = $planInfo['mbt'];
$currentUnit = $planInfo['unit'];
$currentPrice = $planInfo['price'];
$currentLength = $planInfo['length'];
$currentconcurrents = $planInfo['concurrents'];
$currentprivate = $planInfo['private'];
function selectedUnit($check, $currentUnit)
{
	if ($currentUnit == $check)
	{
		return 'selected="selected"';
	}
}

function selectedPrivate($check, $currentprivate)
{
	if ($currentprivate == $check)
	{
		return 'selected="selected"';
	}
}
if (!($user -> isAdmin($odb)))
{
	header('location: ../index.php');
	die();
}
?>
<?php
		if (isset($_POST['update']))
		{
			$updateName = $_POST['nameAdd'];
			$updateCishu = $_POST['cishu'];
			$updateUnit = $_POST['unit'];
			$updateLength = $_POST['lengthAdd'];
			$updateMbt = intval($_POST['mbt']);
			$updatePrice = floatval($_POST['price']);
			$updateconcurrents = $_POST['concurrents'];
			$updateprivate = $_POST['private'];
			
			if (empty($updatePrice) || empty($updateName) || empty($updateCishu) || empty($updateUnit) || empty($updateLength) || empty($updateMbt) || empty($updateconcurrents))
			{
				$error = 'Fill in all fields';
			}
			if (empty($error))
			{
				$SQLinsert = $odb -> prepare("UPDATE `plans` SET `name` = :name, `cishu` = :cishu, `mbt` = :mbt, `unit` = :unit, `length` = :length, `price` = :price, `concurrents` = :concurrents, `private` = :private WHERE `ID` = :id");
				$SQLinsert -> execute(array(':name' => $updateName, ':mbt' => $updateMbt, ':cishu' => $updateCishu, ':unit' => $updateUnit, ':length' => $updateLength, ':price' => $updatePrice, ':concurrents' => $updateconcurrents, ':private' => $updateprivate, ':id' => $_GET['id']));
				echo success('套餐已更新');
				$currentName = $updateName;
				$currentCishu = $updateCishu;
				$currentUnit = $updateUnit;
				$currentMbt = $updateMbt;
				$currentPrice = $updatePrice;
				$currentLength = $updateLength;
				$currentconcurrents = $updateconcurrents;
				$currentprivate = $updateprivate;
			}
			else
			{
				echo error($error);
			}
		}
?>			                   
<div class="main-panel">
			<div class="content">
				<div class="page-inner">
					<div class="page-header">
						<h4 class="page-title">套餐管理</h4>
						<ul class="breadcrumbs">
							<li class="nav-home">
								<a href="#">
									<i class="flaticon-home"></i>
								</a>
							</li>
							<li class="separator">
								<i class="flaticon-right-arrow"></i>
							</li>
							<li class="nav-item">
								<a href="ulist.php">套餐管理</a>
							</li>
						</ul>
					</div>
					<div class="row">
						<div class="col-md-12">
							<div class="card">
								<div class="card-header">
									<h4 class="card-title">套餐管理</h4>
								</div>
						<?php echo $plan;?>
						<form class="am-form am-form-horizontal" method="post">
								<div class="card-body">
									<div class="row">
										<div class="col-md-12 col-lg-12">
											<div class="form-group">
												<label for="title2">名称</label>
												<input type="title" name="nameAdd" class="form-control" id="name" placeholder="<?php echo htmlspecialchars($currentName); ?>"value="<?php echo htmlspecialchars($currentName); ?>">
												<small id="nameHelp" class="form-text text-muted">套餐名称</small>
											</div>
											<div class="form-group">
												<label for="password">价格</label>
												<input type="text" name="price" class="form-control" id="price" placeholder="<?php echo htmlspecialchars($currentPrice); ?>"value="<?php echo htmlspecialchars($currentPrice); ?>">
											</div>
											<div class="form-group">
												<label for="password">开机时间</label>
												<input type="text" name="mbt" class="form-control" id="mbt" placeholder="<?php echo htmlspecialchars($currentMbt); ?>" value="<?php echo htmlspecialchars($currentMbt); ?>">
											</div>
											<div class="form-group">
												<label for="password">并发</label>
												<input type="text" name="concurrents" class="form-control" id="concurrents" placeholder="<?php echo htmlspecialchars($currentconcurrents); ?>"value="<?php echo htmlspecialchars($currentconcurrents); ?>">
											</div>
											<div class="form-group">
												<label for="password">次数</label>
												<input type="text" name="cishu" class="form-control" id="cishu" placeholder="<?php echo htmlspecialchars($currentCishu); ?>"value="<?php echo htmlspecialchars($currentCishu); ?>">
											</div>
											<div class="form-group">
												<label for="password">时间</label>
												<input type="text" name="lengthAdd" class="form-control" id="lengthAdd" placeholder="<?php echo htmlspecialchars($currentLength); ?>"value="<?php echo htmlspecialchars($currentLength); ?>">
											</div>
											<div class="form-group">
												<label for="largeSelect">单位</label>
												<select class="form-control form-control-lg" id="unit" name="unit">
<option value="Days" <?php echo selectedUnit('Days',$currentUnit); ?> >天</option>
<option value="Weeks" <?php echo selectedUnit('Weeks', $currentUnit); ?> >周</option>
<option value="Months" <?php echo selectedUnit('Months', $currentUnit); ?> >月</option>
<option value="Years" <?php echo selectedUnit('Years', $currentUnit); ?> >年</option>
												</select>
											</div>
											<div class="form-group">
												<label for="largeSelect">VIP</label>
												<select class="form-control form-control-lg" id="private" name="private">
<option value="0" <?php echo selectedPrivate(0, $currentprivate); ?>>No</option>
<option value="1" <?php echo selectedPrivate(1, $currentprivate); ?>>Yes</option>
												</select>
											</div>
										</div>
									</div>
								</div>
<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="update"  class="btn btn-block btn-success">提交</button>
</div>
</form>
</div>                           
</div>
</div>