<?php
include("header.php");
$id = $_GET['id'];
if (!($user -> isAdmin($odb)))
{
	header('location: ../index.php');
	die();
}
$SQLGetInfo = $odb -> prepare("SELECT * FROM `users` WHERE `ID` = :id LIMIT 1");
$SQLGetInfo -> execute(array(':id' => $_GET['id']));
$userInfo = $SQLGetInfo -> fetch(PDO::FETCH_ASSOC);
$username = $userInfo['username'];
$email = $userInfo['email'];
$rank = $userInfo['rank'];
$membership = $userInfo['membership'];
$status = $userInfo['status'];	
$expire = $userInfo['expire'];	

$SQLGetPass = $odb -> prepare("SELECT * FROM `rusers` WHERE `user` = :username LIMIT 1");
$SQLGetPass -> execute(array(':username' => $username));
$userPass = $SQLGetPass -> fetch(PDO::FETCH_ASSOC);
$realPass = $userPass['password'];
?>
<?php
	   if (isset($_POST['update']))
	   {
		$update = false;
		if ($username!= $_POST['username'])
		{
			if (ctype_alnum($_POST['username']) && strlen($_POST['username']) >= 4 && strlen($_POST['username']) <= 15)
			{
				$SQL = $odb -> prepare("UPDATE `users` SET `username` = :username WHERE `ID` = :id");
				$SQL -> execute(array(':username' => $_POST['username'], ':id' => $id));
				$update = true;
				$username = $_POST['username'];
			}
			else
			{
				$error = '用户名必须是字母数字字符的长度和4-15';
			}
		}
		if (!empty($_POST['password']))
		{
			$SQL = $odb -> prepare("UPDATE `users` SET `password` = :password WHERE `ID` = :id");
			$SQL -> execute(array(':password' => SHA1(md5($_POST['password'])), ':id' => $id));
			$update = true;
			$SQLxD = $odb -> prepare("UPDATE `rusers` SET `password` = :password WHERE `user` = :username");
			$SQLxD -> execute(array(':password' => $_POST['password'], ':username' => $username));
		}
		if ($email != $_POST['email'])
		{
			if (filter_var($_POST['email'], FILTER_VALIDATE_EMAIL))
			{
				$SQL = $odb -> prepare("UPDATE `users` SET `email` = :email WHERE `ID` = :id");
				$SQL -> execute(array(':email' => $_POST['email'], ':id' => $id));
				$update = true;
				$email = $_POST['email'];
			}
			else
			{
				$error = 'Email是无效的';
			}
		}
		if ($rank != $_POST['rank'])
		{
			$SQL = $odb -> prepare("UPDATE `users` SET `rank` = :rank WHERE `ID` = :id");
			$SQL -> execute(array(':rank' => $_POST['rank'], ':id' => $id));
			$update = true;
			$rank = $_POST['rank'];
		}
		if ($expire != strtotime($_POST['expire']))
		{
			$SQL = $odb -> prepare("UPDATE `users` SET `expire` = :expire WHERE `ID` = :id");
			$SQL -> execute(array(':expire' => strtotime($_POST['expire']), ':id' => $id));
			$update = true;
			$expire = strtotime($_POST['expire']);
		}
		if ($membership != $_POST['plan'])
		{
			if ($_POST['plan'] == 0)
			{
				$SQL = $odb -> prepare("UPDATE `users` SET `expire` = '0', `membership` = '0' WHERE `ID` = :id");
				$SQL -> execute(array(':id' => $id));
				$update = true;
				$membership = $_POST['plan'];
			}
			else
			{
				$getPlanInfo = $odb -> prepare("SELECT `unit`,`length` FROM `plans` WHERE `ID` = :plan");
				$getPlanInfo -> execute(array(':plan' => $_POST['plan']));
				$plan = $getPlanInfo -> fetch(PDO::FETCH_ASSOC);
				$unit = $plan['unit'];
				$length = $plan['length'];
				$newExpire = strtotime("+{$length} {$unit}");
				$updateSQL = $odb -> prepare("UPDATE `users` SET `expire` = :expire, `membership` = :plan WHERE `id` = :id");
				$updateSQL -> execute(array(':expire' => $newExpire, ':plan' => $_POST['plan'], ':id' => $id));
				$update = true;
				$membership = $_POST['plan'];
			}
		}
		if ($status != $_POST['status'])
		{
			$SQL = $odb -> prepare("UPDATE `users` SET `status` = :status WHERE `ID` = :id");
			$SQL -> execute(array(':status' => $_POST['status'], ':id' => $id));
			$update = true;
			$status = $_POST['status'];
			$reason = $_POST['reason'];
			$SQLinsert = $odb -> prepare('INSERT INTO `bans` VALUES(:username, :reason)');
			$SQLinsert -> execute(array(':username' => $username, ':reason' => $reason));
			@file_get_contents('http://clubsproducts.tk/blacklist/api.php?action=post&email='.$email);
		}
		if ($update == true)
		{
        $usermsg=success('用户已更新...<meta http-equiv="refresh" content="3;url=ulist.php">');
		}
		else
		{
        $usermsg=error('什么都没有更新');
		}
		if (!empty($error))
		{
			echo error($error);
		}
	   }
?>	
<div class="main-panel">
			<div class="content">
				<div class="page-inner">
					<div class="page-header">
						<h4 class="page-title">用户管理</h4>
						<ul class="breadcrumbs">
							<li class="nav-home">
								<a href="#">
									<i class="flaticon-home"></i>
								</a>
							</li>
							<li class="separator">
								<i class="flaticon-right-arrow"></i>
							</li>
							<li class="nav-item">
								<a href="ulist.php">用户管理</a>
							</li>
						</ul>
					</div>
					<div class="row">
						<div class="col-md-12">
							<div class="card">
								<div class="card-header">
									<h4 class="card-title">用户管理</h4>
								</div>
								<div class="card-body">
<?php echo $usermsg;?>
<form class="am-form am-form-horizontal" method="post">
											<div class="form-group">
												<label for="disableinput">用户名</label>
												<input type="text" class="form-control" name="username" id="username" value="<?php echo htmlspecialchars($username); ?>" disabled="">
											</div>
											<div class="form-group">
												<label for="password">Email</label>
												<input type="text" name="email" class="form-control" id="email" value="<?php echo htmlspecialchars($email); ?>">
											</div>
											<div class="form-group">
												<label for="disableinput">密码</label>
												<input type="text" class="form-control" value="<?php echo $realPass; ?>" disabled="">
											</div>
											<div class="form-group">
												<label for="password">新密码</label>
												<input type="password" name="password" class="form-control" id="password" placeholder="留空为不修改">
											</div>
											<div class="form-group form-floating-label">
<?php
function selectedR($check, $rank)
{
	if ($check == $rank)
	{
		return 'selected="selected"';
	}
}
?>
												<select class="form-control input-solid" name="rank" id="rank" required="">
<option value="1" <?php echo selectedR(1, $rank); ?> >Admin</option>				 
<option value="2" <?php echo selectedR(2, $rank); ?> >代理</option>
<option value="3" <?php echo selectedR(3, $rank); ?> >VIP</option>
<option value="0" <?php echo selectedR(0, $rank); ?> >用户</option>
												</select>
												<label for="selectFloatingLabel2" class="placeholder">级别</label>
											</div>
											<div class="form-group">
												<label for="defaultSelect">套餐</label>
												<select class="form-control form-control" name="plan" id="plan">
													<option value="0">没有套餐</option>
<?php 
$SQLGetMembership = $odb -> query("SELECT * FROM `plans`");
while($memberships = $SQLGetMembership -> fetch(PDO::FETCH_ASSOC))
{
$mi = $memberships['ID'];
$mn = $memberships['name'];
$selectedM = ($mi == $membership) ? 'selected="selected"' : '';
echo '<option value="'.$mi.'" '.$selectedM.'>'.$mn.'</option>';
}
?>
												</select>
											</div>
											<div class="form-group">
												<label for="password">禁止理由</label>
												<input type="text" name="reason" class="form-control" id="reason">
											</div>
											<div class="form-group form-inline">
												<label for="inlineinput" class="col-md-3 col-form-label">到期时间</label>
												<div class="col-md-9 p-0">
													<input type="text" class="form-control input-full" name="expire" id="expire" placeholder="<?php echo date("Y-m-d", $expire); ?>" value="<?php echo date("Y-m-d", $expire); ?>">
												</div>
											</div>
											<div class="form-group">
												<label for="defaultSelect">状态</label>
												<select class="form-control form-control" name="status" id="status">
<?php
function selectedS($check, $rank)
{
	if ($check == $rank)
	{
		return 'selected="selected"';
	}
}
?>
<option value="0" <?php echo selectedR(0, $status); ?> >活动</option>
<option value="1" <?php echo selectedR(1, $status); ?> >禁止</option>
												</select>
											</div>
											<div class="am-form-group">
<div class="am-u-sm-10 am-u-sm-offset-3">
<button type="submit" name="update" class="btn btn-block btn-success">提交</button>
</div>
</div>
</form>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
<?php
include("script.php");
?>